OGRE: Ogre::MemoryDataStream Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::MemoryDataStream Class Reference
Core » Resources

Common subclass of DataStream for handling data from chunks of memory. More...

`#include <OgreDataStream.h>`

Inheritance diagram for Ogre::MemoryDataStream:
[legend]

## Public Member Functions
| MemoryDataStream (const DataStreamPtr &sourceStream, bool freeOnClose=true, bool readOnly=false)
| Create a stream which pre-buffers the contents of another stream.
| MemoryDataStream (const String &name, const DataStreamPtr &sourceStream, bool freeOnClose=true, bool readOnly=false)
| Create a named stream which pre-buffers the contents of another stream.
| MemoryDataStream (const String &name, DataStream &sourceStream, bool freeOnClose=true, bool readOnly=false)
| Create a named stream which pre-buffers the contents of another stream.
| MemoryDataStream (const String &name, size_t size, bool freeOnClose=true, bool readOnly=false)
| Create a named stream with a brand new empty memory chunk.
| MemoryDataStream (const String &name, void *pMem, size_t size, bool freeOnClose=false, bool readOnly=false)
| Wrap an existing memory chunk in a named stream.
| MemoryDataStream (DataStream &sourceStream, bool freeOnClose=true, bool readOnly=false)
| Create a stream which pre-buffers the contents of another stream.
| MemoryDataStream (size_t size, bool freeOnClose=true, bool readOnly=false)
| Create a stream with a brand new empty memory chunk.
| MemoryDataStream (void *pMem, size_t size, bool freeOnClose=false, bool readOnly=false)
| Wrap an existing memory chunk in a stream.
| ~MemoryDataStream ()
void | close (void) override
| Close the stream; this makes further operations invalid.
bool | eof (void) const override
| Returns true if the stream has reached the end.
uchar * | getCurrentPtr (void)
| Get a pointer to the current position in the memory block this stream holds.
uchar * | getPtr (void)
| Get a pointer to the start of the memory block this stream holds.
size_t | read (void *buf, size_t count) override
| Read the requisite number of bytes from the stream, stopping at the end of the file.
size_t | readLine (char *buf, size_t maxCount, const String &delim="\n") override
| Get a single line from the stream.
void | seek (size_t pos) override
| Repositions the read point to a specified byte.
void | setFreeOnClose (bool free)
| Sets whether or not to free the encapsulated memory on close.
void | skip (long count) override
| Skip a defined number of bytes.
size_t | skipLine (const String &delim="\n") override
| Skip a single line from the stream.
size_t | tell (void) const override
| Returns the current byte offset from beginning.
size_t | write (const void *buf, size_t count) override
| Write the requisite number of bytes from the stream (only applicable to streams that are not read-only).
Public Member Functions inherited from Ogre::DataStream
| DataStream (const String &name, uint16 accessMode=READ)
| Constructor for creating named streams.
| DataStream (uint16 accessMode=READ)
| Constructor for creating unnamed streams.
virtual | ~DataStream ()
uint16 | getAccessMode () const
| Gets the access mode of the stream.
virtual String | getAsString (void)
| Returns a String containing the entire stream.
virtual String | getLine (bool trimAfter=true)
| Returns a String containing the next line of data, optionally trimmed for whitespace.
const String & | getName (void)
| Returns the name of the stream, if it has one.
virtual bool | isReadable () const
| Reports whether this stream is readable.
virtual bool | isWriteable () const
| Reports whether this stream is writeable.
template<typename T>
DataStream & | operator>> (T &val)
size_t | size (void) const
| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.

## Additional Inherited Members
Public Types inherited from Ogre::DataStream
enum | AccessMode { READ = 1 , WRITE = 2 }

## Detailed Description

Common subclass of DataStream for handling data from chunks of memory.

## Constructor & Destructor Documentation

## ◆ MemoryDataStream() [1/8]

Ogre::MemoryDataStream::MemoryDataStream | ( | void * | pMem,
|  | size_t | size,
|  | bool | freeOnClose = false,
|  | bool | readOnly = false )

Wrap an existing memory chunk in a stream.

Parameters

  pMem | Pointer to the existing memory
  size | The size of the memory chunk in bytes
  freeOnClose | If true, the memory associated will be destroyed when the stream is closed. Note: it's important that if you set this option to true, that you allocated the memory using OGRE_ALLOC_T with a category of MEMCATEGORY_GENERAL to ensure the freeing of memory matches up.
  readOnly | Whether to make the stream on this memory read-only once created

References Ogre::DataStream::size().

## ◆ MemoryDataStream() [2/8]

Ogre::MemoryDataStream::MemoryDataStream | ( | const String & | name,
|  | void * | pMem,
|  | size_t | size,
|  | bool | freeOnClose = false,
|  | bool | readOnly = false )

Wrap an existing memory chunk in a named stream.

Parameters

  name | The name to give the stream
  pMem | Pointer to the existing memory
  size | The size of the memory chunk in bytes
  freeOnClose | If true, the memory associated will be destroyed when the stream is destroyed. Note: it's important that if you set this option to true, that you allocated the memory using OGRE_ALLOC_T with a category of MEMCATEGORY_GENERAL ensure the freeing of memory matches up.
  readOnly | Whether to make the stream on this memory read-only once created

References Ogre::DataStream::size().

## ◆ MemoryDataStream() [3/8]

Ogre::MemoryDataStream::MemoryDataStream | ( | DataStream & | sourceStream,
|  | bool | freeOnClose = true,
|  | bool | readOnly = false )

Create a stream which pre-buffers the contents of another stream.

This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit.

Parameters

  sourceStream | Another DataStream which will provide the source of data
  freeOnClose | If true, the memory associated will be destroyed when the stream is destroyed.
  readOnly | Whether to make the stream on this memory read-only once created

References Ogre::DataStream::DataStream().

## ◆ MemoryDataStream() [4/8]

Ogre::MemoryDataStream::MemoryDataStream | ( | const DataStreamPtr & | sourceStream,
|  | bool | freeOnClose = true,
|  | bool | readOnly = false )

Create a stream which pre-buffers the contents of another stream.

This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit.

Parameters

  sourceStream | Another DataStream which will provide the source of data
  freeOnClose | If true, the memory associated will be destroyed when the stream is destroyed.
  readOnly | Whether to make the stream on this memory read-only once created

## ◆ MemoryDataStream() [5/8]

Ogre::MemoryDataStream::MemoryDataStream | ( | const String & | name,
|  | DataStream & | sourceStream,
|  | bool | freeOnClose = true,
|  | bool | readOnly = false )

Create a named stream which pre-buffers the contents of another stream.

This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit.

Parameters

  name | The name to give the stream
  sourceStream | Another DataStream which will provide the source of data
  freeOnClose | If true, the memory associated will be destroyed when the stream is destroyed.
  readOnly | Whether to make the stream on this memory read-only once created

References Ogre::DataStream::DataStream().

## ◆ MemoryDataStream() [6/8]

Ogre::MemoryDataStream::MemoryDataStream | ( | const String & | name,
|  | const DataStreamPtr & | sourceStream,
|  | bool | freeOnClose = true,
|  | bool | readOnly = false )

Create a named stream which pre-buffers the contents of another stream.

This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit.

Parameters

  name | The name to give the stream
  sourceStream | Another DataStream which will provide the source of data
  freeOnClose | If true, the memory associated will be destroyed when the stream is destroyed.
  readOnly | Whether to make the stream on this memory read-only once created

## ◆ MemoryDataStream() [7/8]

Ogre::MemoryDataStream::MemoryDataStream | ( | size_t | size,
|  | bool | freeOnClose = true,
|  | bool | readOnly = false )

Create a stream with a brand new empty memory chunk.

Parameters

  size | The size of the memory chunk to create in bytes
  freeOnClose | If true, the memory associated will be destroyed when the stream is destroyed.
  readOnly | Whether to make the stream on this memory read-only once created

References Ogre::DataStream::size().

## ◆ MemoryDataStream() [8/8]

Ogre::MemoryDataStream::MemoryDataStream | ( | const String & | name,
|  | size_t | size,
|  | bool | freeOnClose = true,
|  | bool | readOnly = false )

Create a named stream with a brand new empty memory chunk.

Parameters

  name | The name to give the stream
  size | The size of the memory chunk to create in bytes
  freeOnClose | If true, the memory associated will be destroyed when the stream is destroyed.
  readOnly | Whether to make the stream on this memory read-only once created

References Ogre::DataStream::size().

## ◆ ~MemoryDataStream()

Ogre::MemoryDataStream::~MemoryDataStream | ( |  | ) |

## Member Function Documentation

## ◆ getPtr()

uchar * Ogre::MemoryDataStream::getPtr | ( | void |  | ) |
| inline

Get a pointer to the start of the memory block this stream holds.

## ◆ getCurrentPtr()

uchar * Ogre::MemoryDataStream::getCurrentPtr | ( | void |  | ) |
| inline

Get a pointer to the current position in the memory block this stream holds.

## ◆ read()

size_t Ogre::MemoryDataStream::read | ( | void * | buf,
|  | size_t | count )
| overridevirtual

Read the requisite number of bytes from the stream, stopping at the end of the file.

Parameters

  buf | Reference to a buffer pointer
  count | Number of bytes to read

Returns
  The number of bytes read

Implements Ogre::DataStream.

## ◆ write()

size_t Ogre::MemoryDataStream::write | ( | const void * | buf,
|  | size_t | count )
| overridevirtual

Write the requisite number of bytes from the stream (only applicable to streams that are not read-only).

Parameters

  buf | Pointer to a buffer containing the bytes to write
  count | Number of bytes to write

Returns
  The number of bytes written

Reimplemented from Ogre::DataStream.

## ◆ readLine()

size_t Ogre::MemoryDataStream::readLine | ( | char * | buf,
|  | size_t | maxCount,
|  | const String & | delim = "\n" )
| overridevirtual

Get a single line from the stream.

The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters

  buf | Reference to a buffer pointer
  maxCount | The maximum length of data to be read, excluding the terminating character
  delim | The delimiter to stop at

Returns
  The number of bytes read, excluding the terminating character

Reimplemented from Ogre::DataStream.

## ◆ skipLine()

size_t Ogre::MemoryDataStream::skipLine | ( | const String & | delim = "\n" | ) |
| overridevirtual

Skip a single line from the stream.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

  delim The delimiter(s) to stop at

Returns
  The number of bytes skipped

Reimplemented from Ogre::DataStream.

## ◆ skip()

void Ogre::MemoryDataStream::skip | ( | long | count | ) |
| overridevirtual

Skip a defined number of bytes.

This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.

Implements Ogre::DataStream.

## ◆ seek()

void Ogre::MemoryDataStream::seek | ( | size_t | pos | ) |
| overridevirtual

Repositions the read point to a specified byte.

Implements Ogre::DataStream.

## ◆ tell()

size_t Ogre::MemoryDataStream::tell | ( | void |  | ) | const
| overridevirtual

Returns the current byte offset from beginning.

Implements Ogre::DataStream.

## ◆ eof()

bool Ogre::MemoryDataStream::eof | ( | void |  | ) | const
| overridevirtual

Returns true if the stream has reached the end.

Implements Ogre::DataStream.

## ◆ close()

void Ogre::MemoryDataStream::close | ( | void |  | ) |
| overridevirtual

Close the stream; this makes further operations invalid.

Implements Ogre::DataStream.

## ◆ setFreeOnClose()

void Ogre::MemoryDataStream::setFreeOnClose | ( | bool | free | ) |
| inline

Sets whether or not to free the encapsulated memory on close.

The documentation for this class was generated from the following file:

- OgreDataStream.h